import { default as MultiPolygon } from 'ol/geom/MultiPolygon';
import { TypedClassArgs } from '../../types';
import { DefineComponent, ComputedRef, ComponentOptionsMixin, PublicProps, ExtractPropTypes, PropType } from 'vue';
import { GeometryLayout } from 'ol/geom/Geometry';

type Args = TypedClassArgs<typeof MultiPolygon, [
    "coordinates",
    "layout",
    "endss"
]>;
type Props = {
    coordinates: Args["coordinates"];
    layout?: Args["layout"];
    endss?: Args["endss"];
};
declare const _default: DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    layout: string;
}>, {
    geometry: ComputedRef<MultiPolygon>;
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {}, string, PublicProps, Readonly< ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    layout: string;
}>>>, {
    layout: GeometryLayout;
}, {}>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: PropType<T[K]>;
        required: true;
    };
};
type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
