import { KeysMatching, LayerSwitcherOptions, ObjectToFactory } from '../../types';
import { Options } from 'ol/layer/Layer';
import { Source } from 'ol/source';
import { default as VectorSource } from 'ol/source/Vector';

export type LayersCommonProps<T extends Source = VectorSource> = Partial<Options<T>>;
export declare const layersCommonDefaultProps: Options<Source> & LayerSwitcherOptions;
export declare function useDefaults<T extends LayersCommonProps<S>, S extends Source = VectorSource>(overrides?: ObjectToFactory<T>): Omit<T, KeysMatching<T, object>>;
