import { default as VectorImageLayer, Options } from 'ol/layer/VectorImage';
import { LayerSwitcherOptions, KeysMatching } from '../../types';
import { DefineComponent, ShallowRef, ComponentOptionsMixin, PublicProps, ExtractPropTypes, PropType } from 'vue';
import { Feature } from 'ol';
import { Geometry } from 'ol/geom';
import { Vector } from 'ol/source';
import { default as __DTS_DEFAULT_0__ } from 'ol/events/Event';
import { ObjectEvent } from 'ol/Object';
import { default as __DTS_DEFAULT_1__ } from 'ol/render/Event';

type Props = Options & LayerSwitcherOptions;
declare const _default: DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, Omit<Props, KeysMatching<Props, object>>>, {
    vectorImageLayer: ShallowRef<VectorImageLayer< Feature<Geometry>, Vector<Feature<Geometry>>>>;
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    sourceready: (event: __DTS_DEFAULT_0__) => void;
    change: (event: __DTS_DEFAULT_0__) => void;
    error: (event: __DTS_DEFAULT_0__) => void;
    propertychange: (event: ObjectEvent) => void;
    "change:extent": (event: ObjectEvent) => void;
    "change:maxResolution": (event: ObjectEvent) => void;
    "change:maxZoom": (event: ObjectEvent) => void;
    "change:minResolution": (event: ObjectEvent) => void;
    "change:minZoom": (event: ObjectEvent) => void;
    "change:opacity": (event: ObjectEvent) => void;
    "change:source": (event: ObjectEvent) => void;
    "change:visible": (event: ObjectEvent) => void;
    "change:zIndex": (event: ObjectEvent) => void;
    postrender: (event: __DTS_DEFAULT_1__) => void;
    prerender: (event: __DTS_DEFAULT_1__) => void;
}, string, PublicProps, Readonly< ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, Omit<Props, KeysMatching<Props, object>>>>> & {
    onChange?: ((event: __DTS_DEFAULT_0__) => any) | undefined;
    onError?: ((event: __DTS_DEFAULT_0__) => any) | undefined;
    onPropertychange?: ((event: ObjectEvent) => any) | undefined;
    "onChange:extent"?: ((event: ObjectEvent) => any) | undefined;
    "onChange:maxResolution"?: ((event: ObjectEvent) => any) | undefined;
    "onChange:maxZoom"?: ((event: ObjectEvent) => any) | undefined;
    "onChange:minResolution"?: ((event: ObjectEvent) => any) | undefined;
    "onChange:minZoom"?: ((event: ObjectEvent) => any) | undefined;
    "onChange:opacity"?: ((event: ObjectEvent) => any) | undefined;
    "onChange:source"?: ((event: ObjectEvent) => any) | undefined;
    "onChange:visible"?: ((event: ObjectEvent) => any) | undefined;
    "onChange:zIndex"?: ((event: ObjectEvent) => any) | undefined;
    onPostrender?: ((event: __DTS_DEFAULT_1__) => any) | undefined;
    onPrerender?: ((event: __DTS_DEFAULT_1__) => any) | undefined;
    onSourceready?: ((event: __DTS_DEFAULT_0__) => any) | undefined;
}, {}, {}>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: PropType<T[K]>;
        required: true;
    };
};
type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
