import { AtPixelOptions, default as Map, MapOptions } from 'ol/Map';
import { FeatureLike } from 'ol/Feature';
import { SimpleGeometry } from 'ol/geom';
import { Layer } from 'ol/layer';
import { Pixel } from 'ol/pixel';
import { Source } from 'ol/source';
import { Coordinate } from 'ol/coordinate';
import { MapBrowserEvent, MapEvent } from 'ol';
import { ObjectEvent } from 'ol/Object';
import { default as RenderEvent } from 'ol/render/Event';
import { DefineComponent, Ref, ComponentOptionsMixin, PublicProps, ExtractPropTypes, PropType } from 'vue';
import { default as __DTS_DEFAULT_0__ } from 'ol/events/Event';

type Props = MapOptions & {
    instance?: Map;
};
declare function __VLS_template(): {
    default?(_: {}): any;
};
declare const __VLS_component: DefineComponent<__VLS_TypePropsToRuntimeProps<Props>, {
    map: Map;
    mapRef: Ref<string | HTMLElement | undefined, string | HTMLElement | undefined>;
    forEachFeatureAtPixel: (pixel: Pixel, callback: (arg0: FeatureLike, arg1: Layer<Source>, arg2: SimpleGeometry) => unknown, options?: AtPixelOptions) => unknown;
    getCoordinateFromPixel: (pixel: Coordinate) => Coordinate | undefined;
    render: () => void | undefined;
    updateSize: () => void | undefined;
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    change: (event: __DTS_DEFAULT_0__) => void;
    error: (event: __DTS_DEFAULT_0__) => void;
    propertychange: (event: ObjectEvent) => void;
    "change:layerGroup": (event: ObjectEvent) => void;
    "change:size": (event: ObjectEvent) => void;
    "change:target": (event: ObjectEvent) => void;
    "change:view": (event: ObjectEvent) => void;
    click: (event: MapBrowserEvent<UIEvent>) => void;
    dblclick: (event: MapBrowserEvent<UIEvent>) => void;
    singleclick: (event: MapBrowserEvent<UIEvent>) => void;
    loadstart: (event: MapEvent) => void;
    loadend: (event: MapEvent) => void;
    pointerdrag: (event: MapBrowserEvent<UIEvent>) => void;
    pointermove: (event: MapBrowserEvent<UIEvent>) => void;
    movestart: (event: MapEvent) => void;
    moveend: (event: MapEvent) => void;
    postrender: (event: MapEvent) => void;
    precompose: (event: RenderEvent) => void;
    postcompose: (event: RenderEvent) => void;
    rendercomplete: (event: RenderEvent) => void;
}, string, PublicProps, Readonly< ExtractPropTypes<__VLS_TypePropsToRuntimeProps<Props>>> & {
    onChange?: ((event: __DTS_DEFAULT_0__) => any) | undefined;
    onError?: ((event: __DTS_DEFAULT_0__) => any) | undefined;
    onClick?: ((event: MapBrowserEvent<UIEvent>) => any) | undefined;
    onDblclick?: ((event: MapBrowserEvent<UIEvent>) => any) | undefined;
    onLoadstart?: ((event: MapEvent) => any) | undefined;
    onPointermove?: ((event: MapBrowserEvent<UIEvent>) => any) | undefined;
    onPropertychange?: ((event: ObjectEvent) => any) | undefined;
    onPostrender?: ((event: MapEvent) => any) | undefined;
    "onChange:size"?: ((event: ObjectEvent) => any) | undefined;
    "onChange:target"?: ((event: ObjectEvent) => any) | undefined;
    "onChange:view"?: ((event: ObjectEvent) => any) | undefined;
    onSingleclick?: ((event: MapBrowserEvent<UIEvent>) => any) | undefined;
    onPointerdrag?: ((event: MapBrowserEvent<UIEvent>) => any) | undefined;
    onMovestart?: ((event: MapEvent) => any) | undefined;
    onMoveend?: ((event: MapEvent) => any) | undefined;
    onLoadend?: ((event: MapEvent) => any) | undefined;
    onPrecompose?: ((event: RenderEvent) => any) | undefined;
    onPostcompose?: ((event: RenderEvent) => any) | undefined;
    onRendercomplete?: ((event: RenderEvent) => any) | undefined;
    "onChange:layerGroup"?: ((event: ObjectEvent) => any) | undefined;
}, {}, {}>;
declare const _default: __VLS_WithTemplateSlots<typeof __VLS_component, ReturnType<typeof __VLS_template>>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: PropType<T[K]>;
        required: true;
    };
};
type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
