import { PanIntoViewOptions, Positioning, default as Overlay, Options } from 'ol/Overlay';
import { Coordinate } from 'ol/coordinate';
import { ObjectEvent } from 'ol/Object';
import { DefineComponent, ShallowRef, Ref, ComponentOptionsMixin, PublicProps, ExtractPropTypes, PropType } from 'vue';
import { default as __DTS_DEFAULT_0__ } from 'ol/events/Event';

declare const _default: DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Options>, {
    stopEvent: boolean;
    insertFirst: boolean;
}>, {
    overlay: ShallowRef<Overlay>;
    htmlContent: Ref<HTMLElement | undefined, HTMLElement | undefined>;
    getOffset: () => number[];
    getPosition: () => Coordinate | undefined;
    getPositioning: () => Positioning;
    panIntoView: (optPanIntoViewOptions: PanIntoViewOptions) => void;
    setElement: (element: HTMLElement | undefined) => void;
    setOffset: (offset: number[]) => void;
    setPosition: (position?: Coordinate) => void;
    setPositioning: (positioning: Positioning) => void;
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    change: (event: __DTS_DEFAULT_0__) => void;
    error: (event: __DTS_DEFAULT_0__) => void;
    propertychange: (event: ObjectEvent) => void;
    "change:element": (event: ObjectEvent) => void;
    "change:map": (event: ObjectEvent) => void;
    "change:offset": (event: ObjectEvent) => void;
    "change:position": (event: ObjectEvent) => void;
    "change:positioning": (event: ObjectEvent) => void;
}, string, PublicProps, Readonly< ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Options>, {
    stopEvent: boolean;
    insertFirst: boolean;
}>>> & {
    onChange?: ((event: __DTS_DEFAULT_0__) => any) | undefined;
    onError?: ((event: __DTS_DEFAULT_0__) => any) | undefined;
    onPropertychange?: ((event: ObjectEvent) => any) | undefined;
    "onChange:position"?: ((event: ObjectEvent) => any) | undefined;
    "onChange:element"?: ((event: ObjectEvent) => any) | undefined;
    "onChange:map"?: ((event: ObjectEvent) => any) | undefined;
    "onChange:offset"?: ((event: ObjectEvent) => any) | undefined;
    "onChange:positioning"?: ((event: ObjectEvent) => any) | undefined;
}, {
    insertFirst: boolean;
    stopEvent: boolean;
}, {}>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: PropType<T[K]>;
        required: true;
    };
};
type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
