import { default as ContextMenu, ContextMenuEvent, Options, EventTypes, Item } from 'ol-contextmenu';
import { default as BaseEvent } from 'ol/events/Event';
import { DefineComponent, ComputedRef, ComponentOptionsMixin, PublicProps, ExtractPropTypes, PropType } from 'vue';
import { ObjectEvent } from 'ol/Object';

declare const _default: DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Partial<Options>>, {
    eventType: string;
    defaultItems: boolean;
    width: number;
    items: () => never[];
}>, {
    control: ComputedRef<ContextMenu>;
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    change: (event: BaseEvent) => void;
    error: (event: BaseEvent) => void;
    propertychange: (event: ObjectEvent) => void;
    beforeopen: (event: ContextMenuEvent) => void;
    open: (event: ContextMenuEvent) => void;
    close: (event: BaseEvent) => void;
}, string, PublicProps, Readonly< ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Partial<Options>>, {
    eventType: string;
    defaultItems: boolean;
    width: number;
    items: () => never[];
}>>> & {
    onChange?: ((event: BaseEvent) => any) | undefined;
    onError?: ((event: BaseEvent) => any) | undefined;
    onPropertychange?: ((event: ObjectEvent) => any) | undefined;
    onClose?: ((event: BaseEvent) => any) | undefined;
    onBeforeopen?: ((event: ContextMenuEvent) => any) | undefined;
    onOpen?: ((event: ContextMenuEvent) => any) | undefined;
}, {
    width: number;
    eventType: `${ EventTypes}`;
    defaultItems: boolean;
    items: Item[];
}, {}>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: PropType<T[K]>;
        required: true;
    };
};
type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
