import { default as ImageWMS, Options } from 'ol/source/ImageWMS';
import { Ref, DefineComponent, ShallowRef, ComponentOptionsMixin, PublicProps, ExtractPropTypes, PropType } from 'vue';
import { default as ImageLayer } from 'ol/layer/Image';
import { ImageSourceEvent } from 'ol/source/Image';
import { default as __DTS_DEFAULT_0__ } from 'ol/events/Event';
import { ObjectEvent } from 'ol/Object';
import { ServerType } from 'ol/source/wms';

type Props = Options & {
    layers: string | unknown[];
    styles?: string | unknown[];
    time?: string;
};
declare const _default: DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    hidpi: boolean;
    interpolate: boolean;
    serverType: string;
    styles: string;
    ratio: number;
}>, {
    layer: Ref<ImageLayer<ImageWMS>, ImageLayer<ImageWMS>> | null | undefined;
    source: ShallowRef<ImageWMS>;
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    imageloadend: (event: ImageSourceEvent) => void;
    imageloaderror: (event: ImageSourceEvent) => void;
    imageloadstart: (event: ImageSourceEvent) => void;
    change: (event: __DTS_DEFAULT_0__) => void;
    error: (event: __DTS_DEFAULT_0__) => void;
    propertychange: (event: ObjectEvent) => void;
}, string, PublicProps, Readonly< ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    hidpi: boolean;
    interpolate: boolean;
    serverType: string;
    styles: string;
    ratio: number;
}>>> & {
    onChange?: ((event: __DTS_DEFAULT_0__) => any) | undefined;
    onError?: ((event: __DTS_DEFAULT_0__) => any) | undefined;
    onPropertychange?: ((event: ObjectEvent) => any) | undefined;
    onImageloadend?: ((event: ImageSourceEvent) => any) | undefined;
    onImageloaderror?: ((event: ImageSourceEvent) => any) | undefined;
    onImageloadstart?: ((event: ImageSourceEvent) => any) | undefined;
}, {
    styles: string | unknown[];
    hidpi: boolean;
    interpolate: boolean;
    serverType: ServerType;
    ratio: number;
}, {}>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: PropType<T[K]>;
        required: true;
    };
};
type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
