import { Ref, DefineComponent, ShallowRef, ComponentOptionsMixin, PublicProps, ExtractPropTypes, PropType } from 'vue';
import { default as TileLayer } from 'ol/layer/Tile';
import { default as Tianditu, Options } from './TiandituClass';
import { TileSourceEvent } from 'ol/source/Tile';
import { default as __DTS_DEFAULT_0__ } from 'ol/events/Event';
import { ObjectEvent } from 'ol/Object';
import { Projection } from 'ol/proj';
import { LoadFunction } from 'ol/Tile';
import { RequestEncoding } from 'ol/source/WMTS';

declare const _default: DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Options>, {
    layerType: string;
    isLabel: boolean;
    projection: string;
    requestEncoding: string;
    version: string;
    dimensions: () => {};
    maxZoom: number;
    tileLoadFunction: (imageTile: any, src: any) => void;
    wrapX: boolean;
}>, {
    layer: Ref<TileLayer<Tianditu>, TileLayer<Tianditu>> | null | undefined;
    source: ShallowRef<Tianditu>;
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    tileloadend: (event: TileSourceEvent) => void;
    tileloaderror: (event: TileSourceEvent) => void;
    tileloadstart: (event: TileSourceEvent) => void;
    change: (event: __DTS_DEFAULT_0__) => void;
    error: (event: __DTS_DEFAULT_0__) => void;
    propertychange: (event: ObjectEvent) => void;
}, string, PublicProps, Readonly< ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Options>, {
    layerType: string;
    isLabel: boolean;
    projection: string;
    requestEncoding: string;
    version: string;
    dimensions: () => {};
    maxZoom: number;
    tileLoadFunction: (imageTile: any, src: any) => void;
    wrapX: boolean;
}>>> & {
    onChange?: ((event: __DTS_DEFAULT_0__) => any) | undefined;
    onError?: ((event: __DTS_DEFAULT_0__) => any) | undefined;
    onPropertychange?: ((event: ObjectEvent) => any) | undefined;
    onTileloadend?: ((event: TileSourceEvent) => any) | undefined;
    onTileloaderror?: ((event: TileSourceEvent) => any) | undefined;
    onTileloadstart?: ((event: TileSourceEvent) => any) | undefined;
}, {
    wrapX: boolean;
    projection: string | Projection;
    maxZoom: number;
    tileLoadFunction: LoadFunction;
    requestEncoding: RequestEncoding;
    version: string;
    dimensions: any;
    layerType: string;
    isLabel: boolean;
}, {}>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: PropType<T[K]>;
        required: true;
    };
};
type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
