import { default as VectorSource, Options, VectorSourceEvent } from 'ol/source/Vector';
import { default as VectorLayer } from 'ol/layer/Vector';
import { default as HeatmapLayer } from 'ol/layer/Heatmap';
import { WebGLVectorLayer } from '../layers/WebGLVectorLayerClass';
import { Ref, DefineComponent, ShallowRef, ComponentOptionsMixin, PublicProps, ExtractPropTypes, PropType } from 'vue';
import { default as Feature } from 'ol/Feature';
import { Geometry } from 'ol/geom';
import { default as __DTS_DEFAULT_0__ } from 'ol/events/Event';
import { ObjectEvent } from 'ol/Object';

declare function __VLS_template(): {
    default?(_: {}): any;
};
declare const __VLS_component: DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Options<Feature< Geometry>>>, {
    overlaps: boolean;
    useSpatialIndex: boolean;
    wrapX: boolean;
}>, {
    layer: Ref<VectorLayer<VectorSource<Feature< Geometry>>, Feature< Geometry>>, VectorLayer<VectorSource<Feature< Geometry>>, Feature< Geometry>>> | Ref<HeatmapLayer<Feature< Geometry>, VectorSource<Feature< Geometry>>>, HeatmapLayer<Feature< Geometry>, VectorSource<Feature< Geometry>>>> | Ref<WebGLVectorLayer, WebGLVectorLayer> | null;
    source: ShallowRef<VectorSource<Feature< Geometry>>>;
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    addfeature: (event: VectorSourceEvent<Feature< Geometry>>) => void;
    changefeature: (event: VectorSourceEvent<Feature< Geometry>>) => void;
    clear: (event: VectorSourceEvent<Feature< Geometry>>) => void;
    featuresloadend: (event: VectorSourceEvent<Feature< Geometry>>) => void;
    featuresloaderror: (event: VectorSourceEvent<Feature< Geometry>>) => void;
    featuresloadstart: (event: VectorSourceEvent<Feature< Geometry>>) => void;
    removefeature: (event: VectorSourceEvent<Feature< Geometry>>) => void;
    change: (event: __DTS_DEFAULT_0__) => void;
    error: (event: __DTS_DEFAULT_0__) => void;
    propertychange: (event: ObjectEvent) => void;
}, string, PublicProps, Readonly< ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Options<Feature< Geometry>>>, {
    overlaps: boolean;
    useSpatialIndex: boolean;
    wrapX: boolean;
}>>> & {
    onChange?: ((event: __DTS_DEFAULT_0__) => any) | undefined;
    onError?: ((event: __DTS_DEFAULT_0__) => any) | undefined;
    onPropertychange?: ((event: ObjectEvent) => any) | undefined;
    onClear?: ((event: VectorSourceEvent<Feature< Geometry>>) => any) | undefined;
    onAddfeature?: ((event: VectorSourceEvent<Feature< Geometry>>) => any) | undefined;
    onChangefeature?: ((event: VectorSourceEvent<Feature< Geometry>>) => any) | undefined;
    onFeaturesloadend?: ((event: VectorSourceEvent<Feature< Geometry>>) => any) | undefined;
    onFeaturesloaderror?: ((event: VectorSourceEvent<Feature< Geometry>>) => any) | undefined;
    onFeaturesloadstart?: ((event: VectorSourceEvent<Feature< Geometry>>) => any) | undefined;
    onRemovefeature?: ((event: VectorSourceEvent<Feature< Geometry>>) => any) | undefined;
}, {
    wrapX: boolean;
    overlaps: boolean;
    useSpatialIndex: boolean;
}, {}>;
declare const _default: __VLS_WithTemplateSlots<typeof __VLS_component, ReturnType<typeof __VLS_template>>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: PropType<T[K]>;
        required: true;
    };
};
type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
