import { ProjectionLike } from 'ol/proj';
import { default as WMTSSource, Options as WMTSOptions } from 'ol/source/WMTS';
import { default as TileGridWMTS } from 'ol/tilegrid/WMTS';

export type Options = Partial<WMTSOptions> & {
    tileProxy?: string;
    layerType?: string;
    tk?: string;
    isLabel?: boolean;
    maxZoom?: number;
};
export default class Tianditu extends WMTSSource {
    static layerLabelMap: Record<string, string>;
    static layerZoomMap: Record<string, number>;
    static tileProxy: string | undefined;
    constructor(opts: Options);
    static getTileGrid(projection: ProjectionLike): TileGridWMTS;
    static default4326TileGrid(): TileGridWMTS;
    static default3857TileGrid(): TileGridWMTS;
}
