import { Options } from 'ol/style/Fill';
import { DefineComponent, ComponentOptionsMixin, PublicProps, ExtractPropTypes, PropType } from 'vue';

type GradientColorStop = [number, string];
export type LinearGradient = {
    type: "linear";
    x0: number;
    y0: number;
    x1: number;
    y1: number;
    colorStops: GradientColorStop[];
};
export type RadialGradient = {
    type: "radial";
    x0: number;
    y0: number;
    r0: number;
    x1: number;
    y1: number;
    r1: number;
    colorStops: GradientColorStop[];
};
export type ConicGradient = {
    type: "conic";
    x: number;
    y: number;
    startAngle: number;
    colorStops: GradientColorStop[];
};
export type Gradient = LinearGradient | RadialGradient | ConicGradient;
declare const _default: DefineComponent<__VLS_TypePropsToRuntimeProps<Options & {
    gradient?: Gradient;
}>, {}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {}, string, PublicProps, Readonly< ExtractPropTypes<__VLS_TypePropsToRuntimeProps<Options & {
    gradient?: Gradient;
}>>>, {}, {}>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: PropType<T[K]>;
        required: true;
    };
};
