import { App } from 'vue';
import { default as OlStyle } from './OlStyle.vue';
import { default as OlStyleCircle } from './OlStyleCircle.vue';
import { default as OlStyleStroke } from './OlStyleStroke.vue';
import { default as OlStyleFill, Gradient, ConicGradient, RadialGradient, LinearGradient } from './OlStyleFill.vue';
import { default as OlStyleIcon } from './OlStyleIcon.vue';
import { default as OlStyleText } from './OlStyleText.vue';
import { default as OlStyleFlowline } from './OlStyleFlowline.vue';
import { FeatureLike } from 'ol/Feature';
import { Style } from 'ol/style';
import { Vue3OpenlayersGlobalOptions } from '../../types';

type OverrideStyleFunction = (feature: FeatureLike, currentStyle: Style, resolution: number) => Style | Style[] | void;
declare function install(app: App, options?: Vue3OpenlayersGlobalOptions): void;
declare module "@vue/runtime-core" {
    function inject(key: "ol-options"): Vue3OpenlayersGlobalOptions;
}
export default install;
export { install, OlStyle, OlStyleStroke, OlStyleFill, OlStyleIcon, OlStyleText, OlStyleFlowline, OlStyleCircle, type OverrideStyleFunction, type Gradient, type ConicGradient, type RadialGradient, type LinearGradient, };
